/************************************************************************************/
/*  Program name CAPAPIMP_AP_BANK_AC_USE.sql                                        */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

ALTER TRIGGER AP_BANK_ACCOUNT_USES_CT1 DISABLE;
ALTER TRIGGER AP_BANK_ACCOUNT_USES_CT2 DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPIMP_AP_BANK_AC_USE';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_AP_BANK_ACCOUNT_USES;

	lv_Next_Seq_ID		NUMBER;

BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	AP_BANK_ACCOUNT_USES_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_AP_BANK_ACCOUNT_USES_MAP VALUES
			(
			C1.Bank_Account_Uses_ID,
			lv_Next_Seq_ID
			);

			INSERT INTO AP_BANK_ACCOUNT_USES_ALL
			VALUES
			(
			lv_Next_Seq_ID,											--Bank Account Uses ID,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),			--LAST_UPDATED_BY,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),				--CREATED_BY,
			C1.LAST_UPDATE_LOGIN,
			CAPBRIMP_MAPPING.GetCustIDMapping(C1.CUSTOMER_ID),
			CAPBRIMP_MAPPING.GetCustSiteIDMapping(C1.CUSTOMER_SITE_USE_ID),
			CAPBRIMP_COMMON.GetVendorID_Name(C1.POVENDOR_NAME),		--VENDOR_ID,
			CAPBRIMP_COMMON.GetVendorSiteID(CAPBRIMP_COMMON.GetVendorID_Name(C1.POVENDOR_NAME),C1.ORG_ID,C1.POVENDORSITE_NAME),	--VENDOR_SITE_ID,
			--CAPBRIMP_COMMON.GetVendorSiteID(C1.ORG_ID),	--VENDOR_SITE_ID,
			CAPBRIMP_MAPPING.GetBankACMapping(C1.EXTERNAL_BANK_ACCOUNT_ID),
			C1.START_DATE,
			C1.END_DATE,
			C1.PRIMARY_FLAG,
			C1.ATTRIBUTE_CATEGORY,
			C1.ATTRIBUTE1,
			C1.ATTRIBUTE2,
			C1.ATTRIBUTE3,
			C1.ATTRIBUTE4,
			C1.ATTRIBUTE5,
			C1.ATTRIBUTE6,
			C1.ATTRIBUTE7,
			C1.ATTRIBUTE8,
			C1.ATTRIBUTE9,
			C1.ATTRIBUTE10,
			C1.ATTRIBUTE11,
			C1.ATTRIBUTE12,
			C1.ATTRIBUTE13,
			C1.ATTRIBUTE14,
			C1.ATTRIBUTE15,
			C1.REQUEST_ID,
			C1.PROGRAM_APPLICATION_ID,
			C1.PROGRAM_ID,
			C1.PROGRAM_UPDATE_DATE,
			--CAPBRIMP_COMMON.GetOrgID(C1.ORG_NAME),						--ORG_ID,
			CAPBRIMP_MAPPING.GetOrgMapping(C1.ORG_ID),						--ORG_ID,
			C1.OWNING_PARTY_ID
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

ALTER TRIGGER AP_BANK_ACCOUNT_USES_CT1 ENABLE;
ALTER TRIGGER AP_BANK_ACCOUNT_USES_CT2 ENABLE;